module(..., package.seeall)

-- Load libraries
require("modelfunctions")
require("fs")
require("format")

-- Set variables
local processname = "clamd"
local packagename = "clamav"
local filelist = {"/etc/clamav/clamd.conf", "/etc/clamav/freshclam.conf"}

local path = "PATH=/usr/local/bin:/usr/bin:/bin:/usr/local/sbin:/usr/sbin:/sbin "

-- ################################################################################
-- LOCAL FUNCTIONS

-- ################################################################################
-- PUBLIC FUNCTIONS

function startstop_service(action)
	return modelfunctions.startstop_service(processname, action)
end

function getstatus()
	return modelfunctions.getstatus(processname, packagename, "ClamAV Status")
end

function getstatusdetails()
	return cfe({ type="longtext", value="", label="ClamAV Status Details" })
end

function getfilelist()
	local listed_files = {}

	for i,name in ipairs(filelist) do
		local filedetails = fs.stat(name) or {}
		table.insert ( listed_files , {filename=name, mtime=filedetails.mtime or "---", filesize=filedetails.size or "0"} )
	end

	table.sort(listed_files, function (a,b) return (a.filename < b.filename) end )

	return cfe({ type="list", value=listed_files, label="ClamAV File List" })
end

function getfiledetails(filename)
	return modelfunctions.getfiledetails(filename, filelist)
end

function updatefiledetails(filedetails)
	return modelfunctions.setfiledetails(filedetails, filelist)
end
